
#ifndef blob_inc
#define blob_inc

#include <stdio.h>
#include "csgobj.h"
#include "blobobj.h"

class blob : public csgobj
{
protected:
	list<blobobj*>	bloblist;
	double		treshhold;

public:
	blob(base *p=NULL,char *n="Untitled",double treshhold=1);
	~blob();

	virtual int	addToParent(base*);
	virtual int	removeFromParent();

	virtual int	exportPOV(FILE*,int,int);
	virtual void	dumpNames(int,int);

	virtual int	addChild(blobobj*);
	virtual int	removeChild(blobobj*);

	virtual void	getChildren(base ***b)
	{
		int	t;
		base	**bt;

		*b = NULL;
		bt = (base**)malloc(sizeof(base*) * (bloblist.length() + 2));
		if(!bt) return;

		for(t = 0;t < bloblist.length();t++)
			bt[t] = bloblist[t];
		bt[t] = NULL;
		*b = bt;
	}

	virtual int	save(FILE*);
	virtual int	load(FILE*,int);

	virtual	base	*searchName(char *n);
	virtual int	existsName(char *n);

	virtual int	draw(view *v,Matrix44);
};

#endif
