
#ifndef triangle_inc
#define triangle_inc

#include <stdio.h>
#include "nonsolid.h"

class triangle:public nonsolid
{
public:
	Vector3 edge1,edge2,edge3;
	Vector3 n1,n2,n3;
	int smooth;
	
	triangle(base*p=NULL, char *n="Untitled", double x1=10, double y1=0, double z1=0, double x2=0, double y2=10, double z2=0, double x3=0, double y3=0, double z3=10, int s=0);
	triangle(base *p, char *n, Vector3 v1, Vector3 v2, Vector3 v3);
	~triangle();
	SetNormal(Vector3 v1,Vector3 v2, Vector3 v3, int s);
	SetNormal(double x1, double y1, double z1, double x2, double y2, double z2, double x3, double y3, double z3, int s);

	virtual int exportPOV(FILE* f=NULL, int a=2, int b=2);
	virtual int save(FILE *);
	virtual int load(FILE *,int );

	virtual int addToParent(base*);
	virtual int removeFromParent();

	virtual void dumpNames(int, int);

	virtual int	draw(view *,Matrix44)
	{
		return -3;
	}
};
#endif
